searchNodes=[{"ref":"ExAws.Dynamo.html","title":"ExAws.Dynamo","type":"module","doc":"Operations on the AWS Dynamo service. NOTE: When Mix.env in [:test, :dev] dynamo clients will run by default against Dynamodb local. Basic usage defmodule User do @derive [ExAws.Dynamo.Encodable] defstruct [:email, :name, :age, :admin] end alias ExAws.Dynamo # Create a provisioned users table with a primary key of email [String] # and 1 unit of read and write capacity Dynamo.create_table(&quot;Users&quot;, &quot;email&quot;, %{email: :string}, 1, 1) |&gt; ExAws.request! user = %User{email: &quot;bubba@foo.com&quot;, name: &quot;Bubba&quot;, age: 23, admin: false} # Save the user Dynamo.put_item(&quot;Users&quot;, user) |&gt; ExAws.request! # Retrieve the user by email and decode it as a User struct. result = Dynamo.get_item(&quot;Users&quot;, %{email: user.email}) |&gt; ExAws.request! |&gt; Dynamo.decode_item(as: User) assert user == result General notes All options are handled as underscored atoms instead of camelcased binaries as specified in the Dynamo API. IE IndexName would be :index_name. Anywhere in the API that requires dynamo type annotation ({&quot;S&quot;:&quot;mystring&quot;}) is handled for you automatically. IE ExAws.Dynamo.scan(&quot;Users&quot;, expression_attribute_values: [api_key: &quot;foo&quot;]) Transforms into a query of %{&quot;ExpressionAttributeValues&quot; =&gt; %{api_key: %{&quot;S&quot; =&gt; &quot;foo&quot;}}, &quot;TableName&quot; =&gt; &quot;Users&quot;} Consult the function documentation to see precisely which options are handled this way. If you wish to avoid this kind of automatic behaviour you are free to specify the types yourself. IE: ExAws.Dynamo.scan(&quot;Users&quot;, expression_attribute_values: [api_key: %{&quot;B&quot; =&gt; &quot;Treated as binary&quot;}]) Becomes: %{&quot;ExpressionAttributeValues&quot; =&gt; %{api_key: %{&quot;B&quot; =&gt; &quot;Treated as binary&quot;}}, &quot;TableName&quot; =&gt; &quot;Users&quot;} Alternatively, if what&#39;s being encoded is a struct, you&#39;re always free to implement ExAws.Dynamo.Encodable for that struct. http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Operations.html"},{"ref":"ExAws.Dynamo.html#batch_get_item/2","title":"ExAws.Dynamo.batch_get_item/2","type":"function","doc":"Get up to 100 items (16mb) Map of table names to request parameter maps. http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_BatchGetItem.html Parameters with keys that are automatically annotated with dynamo types are: [:keys] Dynamo.batch_get_item(%{ &quot;Users&quot; =&gt; [ consistent_read: true, keys: [ [api_key: &quot;key1&quot;], [api_key: &quot;api_key2&quot;] ] ], &quot;Subscriptions&quot; =&gt; %{ keys: [ %{id: &quot;id1&quot;} ] } }) As you see you&#39;re largely free to use either keyword args or maps in the body. A map is required for the argument itself because the table names are most often binaries, and I refuse to inflict proplists on anyone."},{"ref":"ExAws.Dynamo.html#batch_write_item/2","title":"ExAws.Dynamo.batch_write_item/2","type":"function","doc":"Put or delete up to 25 items (16mb) Map of table names to request parameter maps. http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_BatchWriteItem.html Parameters with keys that are automatically annotated with dynamo types are: [:keys]"},{"ref":"ExAws.Dynamo.html#create_table/6","title":"ExAws.Dynamo.create_table/6","type":"function","doc":"Create table key_schema can be a simple binary or atom indicating a simple hash key billing_mode may be either :provisioned (default) or :pay_per_request. If you are creating a :pay-per-request table, you will still need to provide values for read and write capacities, although they will be ignored - you may consider providing nil in those cases."},{"ref":"ExAws.Dynamo.html#create_table/8","title":"ExAws.Dynamo.create_table/8","type":"function","doc":"Create table with secondary indices Each index should follow the format outlined here: http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_CreateTable.html For convenience, the keys in each index map are allowed to be atoms. IE: &quot;KeySchema&quot; in the aws docs can be key_schema: Note that both the global_indexes and local_indexes arguments expect a list of such indices. billing_mode may be either :provisioned (default) or :pay_per_request. If you are creating a :pay-per-request table, you will still need to provide values for read and write capacities, although they will be ignored - you may consider providing nil in those cases. Examples secondary_index = [%{ index_name: &quot;my-global-index&quot;, key_schema: [%{ attribute_name: &quot;email&quot;, key_type: &quot;HASH&quot;, }], provisioned_throughput: %{ read_capacity_units: 1, write_capacity_units: 1, }, projection: %{ projection_type: &quot;KEYS_ONLY&quot;, } }] create_table(&quot;TestUsers&quot;, [id: :hash], %{id: :string, email: :string}, 1, 1, secondary_index, [])"},{"ref":"ExAws.Dynamo.html#decode_item/2","title":"ExAws.Dynamo.decode_item/2","type":"function","doc":"Decode an item returned from Dynamo. This will handle items wrapped in the ordinary get_item response map of %{&quot;Item&quot; =&gt; item}. Example Dynamo.get_item(&quot;users&quot;, %{id: &quot;asdf&quot;}) |&gt; ExAws.request! |&gt; Dynamo.decode_item(as: User) By default this will decode various dynamodb sets into lists. If you&#39;d prefer they be decoded into MapSets instead, set decode_sets: true in your compile-time (not runtime) configuration: config :ex_aws, :dynamodb, decode_sets: true"},{"ref":"ExAws.Dynamo.html#delete_item/3","title":"ExAws.Dynamo.delete_item/3","type":"function","doc":"Delete item in table"},{"ref":"ExAws.Dynamo.html#delete_table/1","title":"ExAws.Dynamo.delete_table/1","type":"function","doc":"Delete Table"},{"ref":"ExAws.Dynamo.html#describe_table/1","title":"ExAws.Dynamo.describe_table/1","type":"function","doc":"Describe table"},{"ref":"ExAws.Dynamo.html#describe_time_to_live/1","title":"ExAws.Dynamo.describe_time_to_live/1","type":"function","doc":"Describe time to live"},{"ref":"ExAws.Dynamo.html#get_item/3","title":"ExAws.Dynamo.get_item/3","type":"function","doc":"Get item from table"},{"ref":"ExAws.Dynamo.html#list_tables/0","title":"ExAws.Dynamo.list_tables/0","type":"function","doc":"List tables"},{"ref":"ExAws.Dynamo.html#put_item/3","title":"ExAws.Dynamo.put_item/3","type":"function","doc":"Put item in table"},{"ref":"ExAws.Dynamo.html#query/2","title":"ExAws.Dynamo.query/2","type":"function","doc":"Query Table Please read: http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Query.html Dynamo.query(&quot;Users&quot;, limit: 1, expression_attribute_values: [desired_api_key: &quot;adminkey&quot;], key_condition_expression: &quot;api_key = :desired_api_key&quot;) Parameters with keys that are automatically annotated with dynamo types are: [:exclusive_start_key, :expression_attribute_names]"},{"ref":"ExAws.Dynamo.html#scan/2","title":"ExAws.Dynamo.scan/2","type":"function","doc":"Scan table Please read http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_Scan.html Dynamo.scan(&quot;Users&quot; limit: 1, expression_attribute_values: [desired_api_key: &quot;adminkey&quot;], expression_attribute_names: %{&quot;#asdf&quot; =&gt; &quot;api_key&quot;}, filter_expression: &quot;#asdf = :desired_api_key&quot;) Generally speaking you won&#39;t need to use :expression_attribute_names. It exists to alias a column name if one of the columns you want to search against is a reserved dynamo word, like Percentile. In this case it&#39;s totally unnecessary as api_key is not a reserved word. Parameters with keys that are automatically annotated with dynamo types are: [:exclusive_start_key, :expression_attribute_names]"},{"ref":"ExAws.Dynamo.html#update_item/3","title":"ExAws.Dynamo.update_item/3","type":"function","doc":"Update item in table For update_args format see http://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_UpdateItem.html"},{"ref":"ExAws.Dynamo.html#update_table/2","title":"ExAws.Dynamo.update_table/2","type":"function","doc":"Update Table"},{"ref":"ExAws.Dynamo.html#update_time_to_live/3","title":"ExAws.Dynamo.update_time_to_live/3","type":"function","doc":"Update time to live"},{"ref":"ExAws.Dynamo.html#t:batch_get_item_opts/0","title":"ExAws.Dynamo.batch_get_item_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:batch_write_item_opts/0","title":"ExAws.Dynamo.batch_write_item_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:delete_item_opts/0","title":"ExAws.Dynamo.delete_item_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:dynamo_billing_types/0","title":"ExAws.Dynamo.dynamo_billing_types/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:dynamo_type_names/0","title":"ExAws.Dynamo.dynamo_type_names/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:exclusive_start_key_vals/0","title":"ExAws.Dynamo.exclusive_start_key_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:expression_attribute_names_vals/0","title":"ExAws.Dynamo.expression_attribute_names_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:expression_attribute_values_vals/0","title":"ExAws.Dynamo.expression_attribute_values_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:get_item/0","title":"ExAws.Dynamo.get_item/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:get_item_opts/0","title":"ExAws.Dynamo.get_item_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:key_definitions/0","title":"ExAws.Dynamo.key_definitions/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:key_schema/0","title":"ExAws.Dynamo.key_schema/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:primary_key/0","title":"ExAws.Dynamo.primary_key/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:put_item_opts/0","title":"ExAws.Dynamo.put_item_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:query_opts/0","title":"ExAws.Dynamo.query_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:return_consumed_capacity_vals/0","title":"ExAws.Dynamo.return_consumed_capacity_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:return_item_collection_metrics_vals/0","title":"ExAws.Dynamo.return_item_collection_metrics_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:return_values_vals/0","title":"ExAws.Dynamo.return_values_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:scan_opts/0","title":"ExAws.Dynamo.scan_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:select_vals/0","title":"ExAws.Dynamo.select_vals/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:table_name/0","title":"ExAws.Dynamo.table_name/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:update_item_opts/0","title":"ExAws.Dynamo.update_item_opts/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.html#t:write_item/0","title":"ExAws.Dynamo.write_item/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.Decodable.html","title":"ExAws.Dynamo.Decodable","type":"protocol","doc":"Allows custom decoding logic for your struct."},{"ref":"ExAws.Dynamo.Decodable.html#decode/1","title":"ExAws.Dynamo.Decodable.decode/1","type":"function","doc":""},{"ref":"ExAws.Dynamo.Decodable.html#t:t/0","title":"ExAws.Dynamo.Decodable.t/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.Decoder.html","title":"ExAws.Dynamo.Decoder","type":"module","doc":""},{"ref":"ExAws.Dynamo.Decoder.html#binary_map_to_struct/2","title":"ExAws.Dynamo.Decoder.binary_map_to_struct/2","type":"function","doc":"Converts a map with binary keys to the specified struct"},{"ref":"ExAws.Dynamo.Decoder.html#binary_to_number/1","title":"ExAws.Dynamo.Decoder.binary_to_number/1","type":"function","doc":"Attempts to convert a number to a float, and then an integer"},{"ref":"ExAws.Dynamo.Decoder.html#decode/1","title":"ExAws.Dynamo.Decoder.decode/1","type":"function","doc":"Convert dynamo format to elixir Functions which convert the dynamo style values into normal elixir values. Use these if you just want the dynamo result to look more like elixir without coercing it into a particular struct. By default this will decode various dynamodb sets into lists. If you&#39;d prefer they be decoded into MapSets instead, set decode_sets: true in your compile-time (not runtime) configuration: config :ex_aws, :dynamodb, decode_sets: true"},{"ref":"ExAws.Dynamo.Decoder.html#decode/2","title":"ExAws.Dynamo.Decoder.decode/2","type":"function","doc":"Decodes a dynamo response into a struct. If Dynamo.Decodable is implemented for the struct it will be called after the completion of the coercion. This is important for handling nested maps if you wanted the nested maps to have atom keys."},{"ref":"ExAws.Dynamo.Encodable.html","title":"ExAws.Dynamo.Encodable","type":"protocol","doc":""},{"ref":"ExAws.Dynamo.Encodable.html#encode/2","title":"ExAws.Dynamo.Encodable.encode/2","type":"function","doc":"Converts an elixir value into a map tagging the value with its dynamodb type"},{"ref":"ExAws.Dynamo.Encodable.html#t:t/0","title":"ExAws.Dynamo.Encodable.t/0","type":"type","doc":""},{"ref":"ExAws.Dynamo.Encoder.html","title":"ExAws.Dynamo.Encoder","type":"module","doc":"Takes an elixir value and converts it into a dynamo style map. MapSet.new [1,2,3] |&gt; Elixir.ExAws.Dynamo.Encoder.encode #=&gt; %{&quot;NS&quot; =&gt; [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;]} MapSet.new [&quot;A&quot;,&quot;B&quot;,&quot;C&quot;] |&gt; Elixir.ExAws.Dynamo.Encoder.encode #=&gt; %{&quot;SS&quot; =&gt; [&quot;A&quot;, &quot;B&quot;, &quot;C&quot;]} &quot;bubba&quot; |&gt; ExAws.Dynamo.Encoder.encode #=&gt; %{&quot;S&quot; =&gt; &quot;bubba&quot;} This is handled via the ExAws.Dynamo.Encodable protocol."},{"ref":"ExAws.Dynamo.Encoder.html#atom_to_dynamo_type/1","title":"ExAws.Dynamo.Encoder.atom_to_dynamo_type/1","type":"function","doc":""},{"ref":"ExAws.Dynamo.Encoder.html#encode/1","title":"ExAws.Dynamo.Encoder.encode/1","type":"function","doc":""},{"ref":"ExAws.Dynamo.Encoder.html#encode/2","title":"ExAws.Dynamo.Encoder.encode/2","type":"function","doc":""},{"ref":"ExAws.Dynamo.Encoder.html#encode!/2","title":"ExAws.Dynamo.Encoder.encode!/2","type":"function","doc":""},{"ref":"ExAws.Dynamo.Encoder.html#encode_root/2","title":"ExAws.Dynamo.Encoder.encode_root/2","type":"function","doc":""}]